if (type(AzTableRecycler) == "table") and (AzTableRecycler.vers >= 1) then
	return;
end

local storage = {};
AzTableRecycler = { vers = 1, storage = storage };

local function Recycle(tbl,recursive)
	for k, v in next, tbl do
		if (type(v) == "table") then
			if (recursive) then
				Recycle(v,1);
			else
				wipe(v);
			end
			storage[#storage + 1] = v;
		end
		tbl[k] = nil;
	end
end

function AzTableRecycler.RecycleSub(tbl,recursive)
	Recycle(tbl,recursive);
	return tbl;
end

function AzTableRecycler.RecycleAll(tbl,recursive)
	Recycle(tbl,recursive);
	storage[#storage + 1] = tbl;
end

function AzTableRecycler.GetTable()
	return #storage > 0 and tremove(storage,#storage) or {};
end